<template>
  <q-no-ssr>
    <div
      class="bg-light-blue window-height window-width row justify-center items-center"
    >
      <div class="column">
        <div class="row">
          <h5 class="text-h5 text-white q-my-md">Login</h5>
        </div>
        <div class="row">
          <q-card square bordered class="q-pa-lg shadow-1">
            <q-card-section>
              <q-form class="q-gutter-md">
                <q-input
                  square
                  filled
                  v-model="email"
                  type="text"
                  label="Email"
                />
                <q-input
                  square
                  filled
                  v-model="password"
                  type="password"
                  label="Password"
                />
              </q-form>
            </q-card-section>
            <q-card-actions class="q-px-md">
              <q-btn
                unelevated
                color="light-blue-7"
                size="lg"
                class="full-width"
                label="Login"
                @click="login"
              />
            </q-card-actions>
          </q-card>
        </div>
      </div>
    </div>
  </q-no-ssr>
</template>

<script>
import { LocalStorage } from 'quasar';
import { localAPI } from 'src/boot/axios';
import { ref } from 'vue';

export default {
  name: 'LoginPage',

  setup() {
    const email = ref('');
    const password = ref('');
    return {
      email,
      password,
      async login() {
        try {
          const res = await localAPI.post('/auth/login', {
            email: email.value,
            password: password.value,
          });
          if (res.data.meta?.status === 'success') {
            const token = res.data.payload?.auth_token;
            if (token) {
              LocalStorage.set('auth_token', token);
            }
            window.location.href = '/admin/dashboard';
          } else {
            alert(res.data.meta?.errorMessage);
          }
        } catch (err) {
          console.error(err);
        }
      },
    };
  },
  async beforeRouteEnter(_to, _prev, next) {
    const token = LocalStorage.getItem('auth_token');
    if (token) {
      try {
        const res = await localAPI.post(
          '/auth/login',
          {},
          {
            headers: {
              auth_token: token,
            },
          }
        );
        if (res.data.meta?.status === 'success') {
          next('/admin/dashboard');
        } else {
          LocalStorage.remove('auth_token');
          next();
        }
      } catch (err) {
        LocalStorage.remove('auth_token');
        next();
      }
    } else {
      next();
    }
  },
};
</script>
